Certbot.plugins.common has no attribute 'TLSSNI01'

In my build I install certbot using:
add-apt-repository universe && add-apt-repository ppa:certbot/certbot && apt-get -y update && apt-get -y install certbot

I ran this command:
certbot --version (or with any arguments that where tested in the past)

It produced this output:
AttributeError: module ‘certbot.plugins.common’ has no attribute ‘TLSSNI01’

The operating system my web server runs on is (include version):
Ubuntu 18.04

The version of my client is (e.g. output of certbot --version or certbot-auto --version if you’re using Certbot):
apt-cache policy certbot | grep -i Installed
Installed: 0.31.0-1+ubuntu18.04.1+certbot+1


that challenge was removed due to vulnerability

Can you post the rest of the traceback? It may have been displayed, or it may have only been logged in /var/log/letsencrypt/letsencrypt.log.

Are all packages up-to-date?

1 Like

Thank you for your response:

Here’s the trace:

20-01-02 12:37:01,799:DEBUG:certbot._internal.log:Exiting abnormally:
Traceback (most recent call last):
File “/usr/local/bin/certbot”, line 11, in
sys.exit(main())
File “/usr/local/lib/python3.6/dist-packages/certbot/main.py”, line 14, in main
return internal_main.main(cli_args)
File “/usr/local/lib/python3.6/dist-packages/certbot/_internal/main.py”, line 1320, in main
plugins = plugins_disco.PluginsRegistry.find_all()
File “/usr/local/lib/python3.6/dist-packages/certbot/_internal/plugins/disco.py”, line 208, in find_all
plugin_ep = PluginEntryPoint(entry_point)
File “/usr/local/lib/python3.6/dist-packages/certbot/_internal/plugins/disco.py”, line 50, in init
self.plugin_cls = entry_point.load()
File “/usr/local/lib/python3.6/dist-packages/pkg_resources/init.py”, line 2443, in load
return self.resolve()
File “/usr/local/lib/python3.6/dist-packages/pkg_resources/init.py”, line 2449, in resolve
module = import(self.module_name, fromlist=[‘name’], level=0)
File “/usr/lib/python3/dist-packages/certbot_apache/entrypoint.py”, line 4, in
from certbot_apache import configurator
File “/usr/lib/python3/dist-packages/certbot_apache/configurator.py”, line 32, in
from certbot_apache import http_01
File “/usr/lib/python3/dist-packages/certbot_apache/http_01.py”, line 13, in
class ApacheHttp01(common.TLSSNI01):
File “/usr/local/lib/python3.6/dist-packages/certbot/plugins/common.py”, line 445, in getattr
return getattr(self._module, attr)
AttributeError: module ‘certbot.plugins.common’ has no attribute ‘TLSSNI01’
2020-01-02 12:37:01,800:ERROR:certbot._internal.log:An unexpected error occurred:

You also need to install python-certbot-apache, per the instructions at https://certbot.eff.org/lets-encrypt/ubuntubionic-apache.

sudo apt-get install certbot python-certbot-apache

In more detail, it seems like you may have a different version of the python-certbot-apache plugin installed, which might not be compatible.

It looks like you have at least two installations of different, incompatible versions of Certbot mixed together.

The installation in /usr would be from the apt packages; the installation in /usr/local might have been done with “sudo pip3 install” or something.

A simple option might be to remove the installation from /usr/local and keep the – probably older – one in /usr.

1 Like

Please see also

(@bmw’s response in another thread about this same error)

1 Like

This topic was automatically closed 30 days after the last reply. New replies are no longer allowed.